Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/serial.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/serial.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/serial.h	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
@@ -48,9 +47,9 @@
 #define TOPPERS_SERIAL_H
 
-#include <kernel.h>
-
 #ifdef __cplusplus
 extern "C" {
 #endif
+
+#include <kernel.h>
 
 /*
@@ -62,4 +61,16 @@
 } T_SERIAL_RPOR;
 
+#ifdef TOPPERS_OMIT_TECS
+/*
+ *  シリアルインタフェースドライバの初期化ルーチン
+ */
+extern void		serial_initialize(intptr_t exinf) throw();
+
+/*
+ *  シリアルインタフェースドライバからの未送信文字の取出し
+ */
+extern bool_t	serial_get_chr(ID portid, char *p_c) throw();
+#endif
+
 /*
  *  シリアルインタフェースドライバのサービスコール
@@ -67,8 +78,13 @@
 extern ER		serial_opn_por(ID portid) throw();
 extern ER		serial_cls_por(ID portid) throw();
-extern ER_UINT	serial_rea_dat(ID portid, char *buf, uint_t len) throw();
+extern ER_UINT	serial_trea_dat(ID portid, char *buf, uint_t len, TMO tmout) throw();
 extern ER_UINT	serial_wri_dat(ID portid, const char *buf, uint_t len) throw();
 extern ER		serial_ctl_por(ID portid, uint_t ioctl) throw();
 extern ER		serial_ref_por(ID portid, T_SERIAL_RPOR *pk_rpor) throw();
+
+Inline ER_UINT	serial_rea_dat(ID portid, char *buf, uint_t len)
+{
+	return serial_trea_dat(portid, buf, len, TMO_FEVR);
+}
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.c	(revision 429)
@@ -0,0 +1,110 @@
+/*
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2019 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ *	シリアルインタフェースドライバのファイルディスクリプタ実装部
+ */
+
+#include <errno.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <termios.h>
+#include "target_serial.h"
+#include "siofd.h"
+#include "serial_api.h"
+
+extern serial_t log_serial;
+
+__attribute__((weak))
+int siofd_open(const char *path, int flags, ...)
+{
+	return -1;
+}
+
+__attribute__((weak))
+int siofd_close(int fd)
+{
+	return -1;
+}
+
+__attribute__((weak))
+ssize_t siofd_read(int fd, void *data, size_t len)
+{
+	char *pos, *end;
+
+	if (fd != STDIN_FILENO)
+		return -1;
+
+	for (pos = (char *)data, *end = &pos[len]; pos < end; pos++) {
+		*pos = serial_getc(&log_serial);
+	}
+
+	return pos - (char *)data;
+}
+
+__attribute__((weak))
+ssize_t siofd_write(int fd, const void *data, size_t len)
+{
+	const char *pos, *end;
+
+	if (fd != STDOUT_FILENO)
+		return -1;
+
+	for (pos = (const char *)data, end = &pos[len]; pos < end; pos++) {
+		serial_putc(&log_serial, *pos);
+	}
+
+	return pos - (char *)data;
+}
+
+__attribute__((weak))
+int siofd_tcsetattr(int fd, int act, const struct termios *tio)
+{
+	return 0;
+}
+
+__attribute__((weak))
+int siofd_tcgetattr(int fd, struct termios *tio)
+{
+	return 0;
+}
+
+__attribute__((weak))
+int siofd_fcntl(int fd, int cmd, ...)
+{
+	return 0;
+}
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.h	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/siofd.h	(revision 429)
@@ -0,0 +1,55 @@
+/*
+ *  TOPPERS PROJECT Home Network Working Group Software
+ * 
+ *  Copyright (C) 2019 Cores Co., Ltd. Japan
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  @(#) $Id$
+ */
+
+/*
+ *	シリアルインタフェースドライバのファイルディスクリプタ実装部
+ */
+
+int siofd_open(const char *path, int flags, ...);
+
+int siofd_close(int fd);
+
+ssize_t siofd_read(int fd, void *data, size_t len);
+
+ssize_t siofd_write(int fd, const void *data, size_t len);
+
+int siofd_tcsetattr(int fd, int act, const struct termios *tio);
+
+int siofd_tcgetattr(int fd, struct termios *tio);
+
+int siofd_fcntl(int fd, int cmd, ...);
+
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/syslog.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/syslog.h	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/syslog.h	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
@@ -55,4 +54,34 @@
 #include <t_syslog.h>
 
+#ifdef TOPPERS_OMIT_TECS
+/*
+ *  ログバッファのサイズ
+ */
+#ifndef TCNT_SYSLOG_BUFFER
+#define TCNT_SYSLOG_BUFFER	32		/* ログバッファのサイズ */
+#endif /* TCNT_SYSLOG_BUFFER */
+
+/*
+ *  システムログ機能の初期化
+ */
+extern void	syslog_initialize(intptr_t exinf) throw();
+#endif
+
+/*
+ *  ログ情報の重要度のビットマップを作るためのマクロ
+ */
+#define LOG_MASK(prio)		(1U << (prio))
+#define LOG_UPTO(prio)		((1U << ((prio) + 1)) - 1)
+
+/*
+ *  パケット形式の定義
+ */
+typedef struct t_syslog_rlog {
+	uint_t	count;		/* ログバッファ中のログの数 */
+	uint_t	lost;		/* 失われたログの数 */
+	uint_t	logmask;	/* ログバッファに記録すべき重要度 */
+	uint_t	lowmask;	/* 低レベル出力すべき重要度 */
+} T_SYSLOG_RLOG;
+
 /*
  *  ログ情報の出力
@@ -68,15 +97,15 @@
  *  出力すべきログ情報の重要度の設定
  */
-extern ER	syslog_msk_log(uint_t logmask, uint_t lowmask) throw();
+extern ER		syslog_msk_log(uint_t logmask, uint_t lowmask) throw();
 
 /*
  *  ログバッファの状態参照
  */
-extern ER	syslog_ref_log(T_SYSLOG_RLOG *pk_rlog) throw();
+extern ER		syslog_ref_log(T_SYSLOG_RLOG *pk_rlog) throw();
 
 /*
  *  低レベル出力によるすべてのログ情報の出力
  */
-extern ER	syslog_fls_log(void) throw();
+extern ER		syslog_fls_log(void) throw();
 
 #ifdef __cplusplus
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tBanner.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tBanner.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tBanner.cdl	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2016 by Embedded and Real-Time Systems Laboratory
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tBannerMain.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tBannerMain.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tBannerMain.c	(revision 429)
@@ -6,5 +6,5 @@
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2004-2017 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -56,5 +56,5 @@
 "Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory\n"
 "                            Toyohashi Univ. of Technology, JAPAN\n"
-"Copyright (C) 2004-2017 by Embedded and Real-Time Systems Laboratory\n"
+"Copyright (C) 2004-2019 by Embedded and Real-Time Systems Laboratory\n"
 "            Graduate School of Information Science, Nagoya Univ., JAPAN\n"
 "%s";
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tBuiltInTestAdaptor.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tBuiltInTestAdaptor.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tBuiltInTestAdaptor.c	(revision 429)
@@ -0,0 +1,59 @@
+/*
+ *  TOPPERS/ASP Kernel
+ *      Toyohashi Open Platform for Embedded Real-Time Systems/
+ *      Advanced Standard Profile Kernel
+ * 
+ *  Copyright (C) 2016 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		自己診断サービスのディスクリプタを取得するサービス
+ */
+
+#include "tBuiltInTestAdaptor_tecsgen.h"
+#include <kernel.h>
+#include <t_syslog.h>
+#include <t_stdlib.h>
+
+/*
+ *  自己診断サービスのディスクリプタの取得
+ */
+ER
+eGetBuiltInTestDescriptor_getDescriptor(Descriptor(sBuiltInTest) *p_desc,
+																	int_t i)
+{
+	*p_desc = cBuiltInTest_refer_to_descriptor(i);
+	return(E_OK);
+}
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.c	(revision 429)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2006-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -43,12 +43,10 @@
 
 #include "tHistogram_tecsgen.h"
-#define syslog_write	cSysLog_write
 #include <t_syslog.h>
-#include <log_output.h>
 
 /* 
  *  実行時間分布計測の初期化（受け口関数）
  */
-void
+ER
 eHistogram_initialize(CELLIDX idx)
 {
@@ -61,4 +59,5 @@
 	VAR_over = 0U;
 	VAR_under = 0U;
+	return(E_OK);
 }
 
@@ -66,5 +65,5 @@
  *  実行時間計測の開始（受け口関数）
  */
-void
+ER
 eHistogram_beginMeasure(CELLIDX idx)
 {
@@ -73,4 +72,5 @@
 	HIST_BM_HOOK();
 	HIST_GET_TIM(&VAR_begin_time);
+	return(E_OK);
 }
 
@@ -78,5 +78,5 @@
  *  実行時間計測の終了（受け口関数）
  */
-void
+ER
 eHistogram_endMeasure(CELLIDX idx)
 {
@@ -103,4 +103,5 @@
 		VAR_under++;
 	}
+	return(E_OK);
 }
 
@@ -108,5 +109,5 @@
  *  実行時間分布計測の表示（受け口関数）
  */
-void
+ER
 eHistogram_print(CELLIDX idx)
 {
@@ -125,3 +126,4 @@
 		syslog_1(LOG_NOTICE, "> INT_MAX : %d", VAR_under);
 	}
+	return(E_OK);
 }
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogram.cdl	(revision 429)
@@ -3,5 +3,5 @@
  *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2016-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -51,20 +51,20 @@
 	 *  実行時間分布計測の初期化
    	 */
-	void	initialize(void);
+	ER	initialize(void);
 
 	/*
 	 *  実行時間計測の開始
 	 */
-	void	beginMeasure(void);
+	ER	beginMeasure(void);
 
 	/*
 	 *  実行時間計測の終了
 	 */
-	void	endMeasure(void);
+	ER	endMeasure(void);
 
 	/*
 	 *  実行時間分布計測の表示
 	 */
-	void	print(void);
+	ER	print(void);
 };
 
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogramAdapter.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogramAdapter.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tHistogramAdapter.c	(revision 429)
@@ -1,8 +1,7 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
- *  Copyright (C) 2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2016-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -48,11 +47,23 @@
 
 /*
+ *  実行時間分布計測IDの範囲の判定
+ */
+#define VALID_HISTID(histid)	(1 <= histid && histid <= N_CP_cHistogram)
+
+/*
  *  実行時間分布計測の初期化（サービスコール）
  */
-void
+ER
 init_hist(ID histid)
 {
-	assert(1 <= histid && histid <= N_CP_cHistogram);
-	return(cHistogram_initialize(histid - 1));
+	ER		ercd;
+
+	if (!VALID_HISTID(histid)) {
+		ercd = E_ID;
+	}
+	else {
+		ercd = cHistogram_initialize(histid - 1);
+	}
+	return(ercd);
 }
 
@@ -60,9 +71,16 @@
  *  実行時間計測の開始
  */
-void
+ER
 begin_measure(ID histid)
 {
-	assert(1 <= histid && histid <= N_CP_cHistogram);
-	return(cHistogram_beginMeasure(histid - 1));
+	ER		ercd;
+
+	if (!VALID_HISTID(histid)) {
+		ercd = E_ID;
+	}
+	else {
+		ercd = cHistogram_beginMeasure(histid - 1);
+	}
+	return(ercd);
 }
 
@@ -70,9 +88,16 @@
  *  実行時間計測の終了
  */
-void
+ER
 end_measure(ID histid)
 {
-	assert(1 <= histid && histid <= N_CP_cHistogram);
-	return(cHistogram_endMeasure(histid - 1));
+	ER		ercd;
+
+	if (!VALID_HISTID(histid)) {
+		ercd = E_ID;
+	}
+	else {
+		ercd = cHistogram_endMeasure(histid - 1);
+	}
+	return(ercd);
 }
 
@@ -80,8 +105,15 @@
  *  実行時間分布計測の表示
  */
-void
+ER
 print_hist(ID histid)
 {
-	assert(1 <= histid && histid <= N_CP_cHistogram);
-	return(cHistogram_print(histid - 1));
+	ER		ercd;
+
+	if (!VALID_HISTID(histid)) {
+		ercd = E_ID;
+	}
+	else {
+		ercd = cHistogram_print(histid - 1);
+	}
+	return(ercd);
 }
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTask.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTask.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTask.cdl	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015 by Ushio Laboratory
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTaskMain.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTaskMain.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tLogTaskMain.c	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -82,5 +81,5 @@
 	}
 	else {
-		for (;;) {
+		while (true) {
 			if (cSysLog_refer(&rlog) < 0) {
 				ercd = E_SYS;
@@ -113,5 +112,5 @@
 			rercd = dly_tsk(ATTR_flushWait);
 			if (rercd < 0) {
-				ercd = (rercd == E_RLWAI) ? rercd : E_SYS;
+				ercd = (MERCD(rercd) == E_RLWAI) ? rercd : E_SYS;
 				goto error_exit;
 			}
@@ -130,5 +129,4 @@
 {
 	SYSLOG	syslog;
-	uint_t	lost;
 	ER_UINT	rercd;
 
@@ -136,19 +134,12 @@
 	syslog_0(LOG_NOTICE, "System logging task is started.");
 
-	for (;;) {
-		lost = 0U;
+	while (true) {
 		while ((rercd = cSysLog_read(&syslog)) >= 0) {
-			lost += (uint_t) rercd;
-			if (lost > 0U) {
-				syslog_lostmsg(lost, logtask_putc);
-				lost = 0U;
+			if (((uint_t) rercd) > 0U) {
+				syslog_lostmsg((uint_t) rercd, logtask_putc);
 			}
 			syslog_print(&syslog, logtask_putc);
-			logtask_putc('\n');
 		}
-		if (lost > 0U) {
-			syslog_lostmsg(lost, logtask_putc);
-		}
-		dly_tsk(ATTR_interval);
+		(void) dly_tsk(ATTR_interval);
 	}
 }
@@ -189,8 +180,5 @@
 			syslog_lostmsg((uint_t) rercd, target_fput_log);
 		}
-		if (syslog.logtype >= LOG_TYPE_COMMENT) {
-			syslog_print(&syslog, target_fput_log);
-			target_fput_log('\n');
-		}
+		syslog_print(&syslog, target_fput_log);
 	}
 }
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.c	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.c	(revision 429)
@@ -0,0 +1,70 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2007-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		SIOドライバによるシステムログの低レベル出力
+ */
+
+#include "tPutLogSIOPort_tecsgen.h"
+
+/*
+ *  システムログの低レベル出力のための初期化
+ *
+ *  初期化ルーチンを呼び出すより前に初期化するために，カーネルのターゲッ
+ *  ト依存部から直接呼び出すための関数．
+ */
+void
+tPutLogSIOPort_initialize(void)
+{
+	cSIOPort_open();
+}
+
+/*
+ *  システムログの低レベル出力のための文字出力（受け口関数）
+ *
+ *  SIOポートに文字が送信できるまでポーリングする．
+ */
+void
+ePutLog_putChar(char c)
+{
+	if(c == '\n'){
+		while (!cSIOPort_putChar('\r')) ;
+	}
+	while (!cSIOPort_putChar(c)) ;
+}
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.cdl	(revision 429)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tPutLogSIOPort.cdl	(revision 429)
@@ -0,0 +1,54 @@
+/*
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
+ * 
+ *  Copyright (C) 2015 by Ushio Laboratory
+ *              Graduate School of Engineering Science, Osaka Univ., JAPAN
+ *  Copyright (C) 2015-2018 by Embedded and Real-Time Systems Laboratory
+ *              Graduate School of Information Science, Nagoya Univ., JAPAN
+ * 
+ *  上記著作権者は，以下の(1)～(4)の条件を満たす場合に限り，本ソフトウェ
+ *  ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
+ *  変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
+ *  (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
+ *      権表示，この利用条件および下記の無保証規定が，そのままの形でソー
+ *      スコード中に含まれていること．
+ *  (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
+ *      用できる形で再配布する場合には，再配布に伴うドキュメント（利用
+ *      者マニュアルなど）に，上記の著作権表示，この利用条件および下記
+ *      の無保証規定を掲載すること．
+ *  (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
+ *      用できない形で再配布する場合には，次のいずれかの条件を満たすこ
+ *      と．
+ *    (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
+ *        作権表示，この利用条件および下記の無保証規定を掲載すること．
+ *    (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
+ *        報告すること．
+ *  (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
+ *      害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
+ *      また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
+ *      由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
+ *      免責すること．
+ * 
+ *  本ソフトウェアは，無保証で提供されているものである．上記著作権者お
+ *  よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
+ *  に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
+ *  アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
+ *  の責任を負わない．
+ * 
+ *  $Id$
+ */
+
+/*
+ *		SIOドライバによるシステムログの低レベル出力のコンポーネント記述
+ *		ファイル
+ */
+
+/*
+ *  システムログの低レベル出力のセルタイプ
+ */
+[singleton]
+celltype tPutLogSIOPort {
+	entry	sPutLog		ePutLog;
+	call	sSIOPort	cSIOPort;
+};
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialAdapter.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialAdapter.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialAdapter.c	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
@@ -83,5 +82,5 @@
  */
 ER_UINT
-serial_rea_dat(ID portid, char *buf, uint_t len)
+serial_trea_dat(ID portid, char *buf, uint_t len, TMO tmout)
 {
 	if (sns_dpn()) {				/* コンテキストのチェック */
@@ -92,5 +91,5 @@
 	}
 
-	return(cSerialPort_read(portid - 1, buf, len));
+	return(cSerialPort_read(portid - 1, buf, len, tmout));
 }
 
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPort.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPort.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPort.cdl	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015 by Ushio Laboratory
@@ -57,5 +56,5 @@
 	ER		open(void);
 	ER		close(void);
-	ER_UINT	read([out,size_is(length)] char *buffer, [in] uint_t length);
+	ER_UINT	read([out,size_is(length)] char *buffer, [in] uint_t length, [in] TMO tmout);
 	ER_UINT	write([in,size_is(length)] const char *buffer, [in] uint_t length);
 	ER		control([in] uint_t ioControl);
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPortMain.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPortMain.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSerialPortMain.c	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2006-2015 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2006-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -242,10 +241,10 @@
 
 /*
- *  シリアルポートへの文字送信
+ *  SIOポートへの文字送信
  *
- *  p_cellcbで指定されるSIOポートに対して，文字cを送信する．文字を送信
- *  レジスタにいれた場合にはtrueを返す．そうでない場合には，送信レジス
- *  タが空いたことを通知するコールバック関数を許可し，falseを返す．この
- *  関数は，CPUロック状態で呼び出される．
+ *  p_cellcbで指定されるシリアルポートに対応するSIOポートに対して，文
+ *  字cを送信する．文字を送信レジスタにいれた場合にはtrueを返す．そう
+ *  でない場合には，送信レジスタが空いたことを通知するコールバック関数
+ *  を許可し，falseを返す．この関数は，CPUロック状態で呼び出される．
  */
 Inline bool_t
@@ -268,5 +267,6 @@
 {
 	bool_t	buffer_full;
-	ER		ercd, rercd;
+	ER_BOOL	ercd;
+	ER		rercd;
 
 	/*
@@ -359,9 +359,9 @@
  *  シリアルポートからの1文字受信
  */
-static bool_t
+static ER_BOOL
 serialPort_readChar(CELLCB *p_cellcb, char *p_c)
 {
 	bool_t	buffer_empty;
-	ER		ercd;
+	ER_BOOL	ercd;
 
 	SVC(loc_cpu(), gen_ercd_sys(p_cellcb));
@@ -397,5 +397,5 @@
  */
 ER_UINT
-eSerialPort_read(CELLIDX idx, char *buffer, uint_t length)
+eSerialPort_read(CELLIDX idx, char *buffer, uint_t length, TMO tmout)
 {
 	CELLCB	*p_cellcb;
@@ -423,6 +423,12 @@
 	while (reacnt < length) {
 		if (buffer_empty) {
-			SVC(rercd = cReceiveSemaphore_wait(),
-										gen_ercd_wait(rercd, p_cellcb));
+			rercd = cReceiveSemaphore_waitTimeout(tmout);
+			if (rercd == E_TMOUT)
+				return E_TMOUT;
+			if (rercd < 0) {
+				gen_ercd_wait(rercd, p_cellcb);
+				ercd = rercd;
+				goto error_exit;
+			}
 		}
 		SVC(rercd = serialPort_readChar(p_cellcb, &c), rercd);
@@ -519,5 +525,5 @@
 	if (VAR_receiveFlowControl != '\0') {
 		/*
-		 *  START/STOP を送信する．
+		 *  START/STOPを送信する．
 		 */
 		(void) cSIOPort_putChar(VAR_receiveFlowControl);
@@ -569,5 +575,5 @@
 		 */
 		VAR_sendStopped = false;
-		if (VAR_sendCount > 0U) {
+		while (VAR_sendCount > 0U) {
 			c = VAR_sendBuffer[VAR_sendReadPointer];
 			if (serialPort_sendChar(p_cellcb, c)) {
@@ -580,4 +586,7 @@
 				VAR_sendCount--;
 			}
+			else {
+				break;
+			}
 		}
 	}
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.c	(revision 429)
@@ -1,10 +1,9 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
  *                              Toyohashi Univ. of Technology, JAPAN
- *  Copyright (C) 2005-2016 by Embedded and Real-Time Systems Laboratory
+ *  Copyright (C) 2005-2018 by Embedded and Real-Time Systems Laboratory
  *              Graduate School of Information Science, Nagoya Univ., JAPAN
  * 
@@ -50,4 +49,15 @@
 #include <t_syslog.h>
 #include <log_output.h>
+
+/*
+ *  トレースログに関する設定
+ */
+#ifdef TOPPERS_ENABLE_TRACE
+#include "arch/tracelog/trace_log.h"
+#endif /* TOPPERS_ENABLE_TRACE */
+
+/*
+ *  ターゲット依存情報の定義
+ */
 #include "target_syssvc.h"
 
@@ -126,5 +136,4 @@
 	if ((VAR_lowMask & LOG_MASK(priority)) != 0U) {
 		syslog_print(p_syslog, low_putchar);
-		low_putchar('\n');
 	}
 
@@ -212,14 +221,11 @@
 
 	while ((rercd = eSysLog_read(&logbuf)) >= 0) {
-		if (rercd > 0) {
+		if (((uint_t) rercd) > 0U) {
 			syslog_lostmsg((uint_t) rercd, low_putchar);
 		}
-		if (logbuf.logtype >= LOG_TYPE_COMMENT) {
-			syslog_print(&logbuf, low_putchar);
-			low_putchar('\n');
-		}
-	}
-
-	SIL_UNL_INT();
-	return(E_OK);
-}
+		syslog_print(&logbuf, low_putchar);
+	}
+
+	SIL_UNL_INT();
+	return(E_OK);
+}
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.cdl
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.cdl	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLog.cdl	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015 by Ushio Laboratory
@@ -46,7 +45,7 @@
 
 /*
- *  システムログ出力に関する定義
+ *  システムログ機能に関する定義
  */
-import_C("t_syslog.h");
+import_C("syssvc/syslog.h");
 
 /*
Index: EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLogAdapter.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLogAdapter.c	(revision 428)
+++ EcnlProtoTool/trunk/asp3_dcre/syssvc/tSysLogAdapter.c	(revision 429)
@@ -1,6 +1,5 @@
 /*
- *  TOPPERS/ASP Kernel
- *      Toyohashi Open Platform for Embedded Real-Time Systems/
- *      Advanced Standard Profile Kernel
+ *  TOPPERS Software
+ *      Toyohashi Open Platform for Embedded Real-Time Systems
  * 
  *  Copyright (C) 2015,2016 by Embedded and Real-Time Systems Laboratory
